/* $Id: mccodimage.h,v 1.5 2004/06/14 13:00:37 michel Exp $ */
#define SHRT_MIN -32767 
#define SHRT_MAX +32767 
#define USHRT_MAX 65535 
#define INT_MIN -32767 
#define INT_MAX +32767 
#define UINT_MAX 65535 
#define LONG_MIN -2147483647 
#define LONG_MAX +2147483647
#define ULONG_MAX 4294967295
#define NDG_MAX 255            /* niveau de gris max */
#define NDG_MIN 0              /* niveau de gris min */

/* definitions for data storage type,
   unsigned long data_storage_type; */
#define	VFF_TYP_BIT		0	/* pixels are on or off (binary image)*/
                                        /* Note: This is an X11 XBitmap 
					   with bits packed into a byte and
					   padded to a byte */
#define	VFF_TYP_1_BYTE		1	/* pixels are byte (unsigned char) */
#define	VFF_TYP_2_BYTE		2	/* pixels are two byte (short int) */
#define	VFF_TYP_4_BYTE		4	/* pixels are four byte (integer) */
#define	VFF_TYP_FLOAT		5	/* pixels are float (single precision)*/
#define VFF_TYP_DOUBLE		9	/* pixels are float (double precision)*/
#define	VFF_TYP_COMPLEX		10      /* pixels are complex float */
#define VFF_TYP_DCOMPLEX	11	/* double complex */
#define VFF_TYP_GABYTE          12      /* graphe d'arete code sur 1 octet */
#ifndef KHOROS
struct xvimage {
  char *name;
  unsigned long row_size;
  unsigned long col_size;
  unsigned long num_data_bands;	    /* Number of bands per data pixel,
				       or number of bands per image, or
				       dimension of vector data, or
				       number of elements in a vector */

  unsigned long data_storage_type;  /* storage type for disk data */
  double xdim, ydim, zdim;          /* voxel dimensions in real world */
  unsigned char imagedata[1];
};
#endif

struct xvimage4D {
  int ss;                            /* sequence size */
  struct xvimage ** frame; 
};

#define UCHARDATA(I) ((unsigned char *)((I)->imagedata))
#define USHORTDATA(I) ((unsigned short *)((I)->imagedata))
#define ULONGDATA(I) ((unsigned long *)((I)->imagedata))
#define FLOATDATA(I) ((float *)((I)->imagedata))
#define DOUBLEDATA(I) ((double *)((I)->imagedata))
#define colsize(I)  ((I)->col_size)
#define rowsize(I)  ((I)->row_size)
#define depth(I)    ((I)->num_data_bands)
#define datatype(I) ((I)->data_storage_type)

/*            
		Codage du voisinage


		3	2	1			
		4	X	0
		5	6	7
*/
#define EST 0
#define NORD 2
#define OUEST 4
#define SUD 6
#define NORD_EST 1
#define NORD_OUEST 3
#define SUD_OUEST 5
#define SUD_EST 7
#define DEVANT 8
#define DERRIERE 10

#define nonbord(p,rs,N) ((p%rs!=rs-1)&&(p>=rs)&&(p%rs!=0)&&(p<N-rs))
#define nonbord3d(p,rs,ps,N) ((p>=ps)&&(p<N-ps)&&(p%ps>=rs)&&(p%ps<ps-rs)&&(p%rs!=0)&&(p%rs!=rs-1))

/* ============== */
/* prototypes     */
/* ============== */

extern int voisin(int i, int k, int rs, int nb);
extern int voisin6(int i, int k, int rs, int n, int nb);
extern int bord(int i, int rs, int nb);
extern int voisin26(int i, int k, int rs, int n, int nb);
extern int voisin18(int i, int k, int rs, int n, int nb);
extern int voisins4(int i, int j, int rs);
extern int voisins8(int i, int j, int rs);   
extern int voisins6(int i, int j, int rs, int ps);   
extern int voisins26(int i, int j, int rs, int ps);   
extern int voisin5(int i, int k, int rs, int nb);
extern int voisin6b(int i, int k, int rs, int nb);
extern int voisinNESO(int i, int k, int rs, int nb);
extern int voisinNOSE(int i, int k, int rs, int nb);
extern int voisin4D8(int i, int k, int rs, int ps, int N, int Nt);
